//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2007 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef EDITOR_H
#define EDITOR_H

#ifdef _MSC_VER
	#pragma once
#endif

#include <vd2/system/refcount.h>
#include "effect.h"

class IVDFilterPreview;
class IVDFilterPreview2;
class VDStringA;

class IVDShaderFilterSource {
public:
	virtual void ReadSource(VDStringA& dst) = 0;
};

struct VDShaderFilterConfig {
	enum {
		kModeDefault,
		kModeInterp,
		kModeScalarJIT,
		kModeCount
	};

	VDShaderFilterConfig()
		: mExecutionMode(kModeDefault)
	{
		mFilename[0] = 0;
	}

	int mExecutionMode;

	char mFilename[MAX_PATH];

	vdrefptr<VDShaderEffect> mpEffect;

	IVDShaderFilterSource *mpSource;
};

void VDRegisterShaderEditor();
void VDUnregisterShaderEditor();
bool VDOpenShaderEditor(HWND hwnd, VDShaderFilterConfig& config, IVDFilterPreview *ifp, IVDFilterPreview2 *ifp2);

#endif
